import {ctor} from './global';
import {initMongoDB} from './setMongodb';
import {EmailFun} from "./public/email";

const shouchong = {
    "shouchong1": {
        "paynum": 6,
        "cartoon": {
            "hero": 5001
        },
        "prize": [
            [
                {
                    "a": "hero",
                    "t": "5001",
                    "n": 1
                },
                {
                    "a": "attr",
                    "t": "jinbi",
                    "n": 100000
                }
            ],
            [
                {
                    "a": "item",
                    "t": "12",
                    "n": 200
                },
                {
                    "a": "attr",
                    "t": "jinbi",
                    "n": 200000
                }
            ],
            [
                {
                    "a": "item",
                    "t": "12",
                    "n": 200
                },
                {
                    "a": "attr",
                    "t": "jinbi",
                    "n": 300000
                }
            ]
        ]
    },
    "shouchong2": {
        "paynum": 30,
        "cartoon": {
            "img": 5001
        },
        "prize": [
            [
                {
                    "a": "equip",
                    "t": "1009",
                    "n": 1
                },
                {
                    "a": "equip",
                    "t": "2009",
                    "n": 1
                }
            ],
            [
                {
                    "a": "equip",
                    "t": "3009",
                    "n": 1
                },
                {
                    "a": "item",
                    "t": "2",
                    "n": 1000
                }
            ],
            [
                {
                    "a": "equip",
                    "t": "4009",
                    "n": 1
                },
                {
                    "a": "item",
                    "t": "2",
                    "n": 1000
                }
            ]
        ]
    },
    "shouchong3": {
        "paynum": 98,
        "cartoon": {
            "hero": 5002
        },
        "prize": [
            [
                {
                    "a": "hero",
                    "t": "5002",
                    "n": 1
                },
                {
                    "a": "item",
                    "t": "4",
                    "n": 10
                }
            ],
            [
                {
                    "a": "equip",
                    "t": "1010",
                    "n": 1
                },
                {
                    "a": "item",
                    "t": "2",
                    "n": 2000
                }
            ],
            [
                {
                    "a": "equip",
                    "t": "3010",
                    "n": 1
                },
                {
                    "a": "item",
                    "t": "2",
                    "n": 2000
                }
            ]
        ]
    }
}

async function start() {
    //连接mongodb
    await initMongoDB();
    let users = await G.mongodb.collection("user").find({}, {
        projection: {uid: 1, payExp: 1}
    }).toArray()

    for (let i = 0; i < users.length; i++) {
        let user = users[i];
        let data = await G.mongodb.cEvent("shouchong").findOne({uid: user.uid});

        let send_prize = [];
        for (let key in shouchong) {
            // 充值不足
            if (user.payExp < shouchong[key]["paynum"] * 10) {
                continue
            }

            // 奖励已经领取完毕
            if (data && data.receive[key] && data.receive[key].length >= shouchong[key]["prize"].length) {
                continue
            }

            // 补发未领取奖励
            for (let i = 0; i < shouchong[key]["prize"].length; i++) {
                if (data.receive[key][i]) {
                    continue
                }
                data.receive[key][i] = G.time;
                send_prize.concat(shouchong[key]["prize"][i]);
            }
        }
        if (send_prize.length <= 0) continue;

        let title = "首充未领取奖励补发";
        let content = "首充未领取奖励补发";

        // 设置奖励发放记录
        await G.mongodb.cEvent("shouchong").updateOne({
            uid: user.uid
        }, {"$set": {receive: data.receive}});

        // 发放邮件
        await EmailFun.addEmail({
            uid: user.uid,
            type: "system",
            title: title,
            content: content,
            prize: send_prize,
        })
    }
}

//定义全局变量
ctor();
//启动服务
start().then(() => {
    process.exit()
});


